/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.MediaDrm$KeyRequest
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.media.MediaDrm');

/**
 * @class android.media.MediaDrm$KeyRequest
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.KeyRequest.html}
 **/
var KeyRequest = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.MediaDrm$KeyRequest')) {
		result = arguments[0];
	}
	else {
		result = KeyRequest.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
KeyRequest.prototype = Object.create(SuperClass.prototype);
KeyRequest.prototype.constructor = KeyRequest;

Object.defineProperty(KeyRequest.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new KeyRequest(this.$native.super);
	},
	enumerable: true
});

KeyRequest.className = 'android.media.MediaDrm$KeyRequest';
KeyRequest.prototype.className = 'android.media.MediaDrm$KeyRequest';

// class property
Object.defineProperty(KeyRequest, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.MediaDrm$KeyRequest');
	},
	enumerable: true,
	configurable: false
});


// Cast
KeyRequest.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new KeyRequest(Hyperloop.cast('android.media.MediaDrm$KeyRequest', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.KeyRequest.html#REQUEST_TYPE_INITIAL}
 */
KeyRequest.REQUEST_TYPE_INITIAL = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.KeyRequest.html#REQUEST_TYPE_RENEWAL}
 */
KeyRequest.REQUEST_TYPE_RENEWAL = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.KeyRequest.html#REQUEST_TYPE_RELEASE}
 */
KeyRequest.REQUEST_TYPE_RELEASE = 2;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getRequestType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.KeyRequest.html#getRequestType()}
 **/
KeyRequest.prototype.getRequestType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRequestType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm$KeyRequest') {
			return new KeyRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDefaultUrl
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.KeyRequest.html#getDefaultUrl()}
 **/
KeyRequest.prototype.getDefaultUrl = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDefaultUrl',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm$KeyRequest') {
			return new KeyRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.KeyRequest.html#getData()}
 **/
KeyRequest.prototype.getData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm$KeyRequest') {
			return new KeyRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = KeyRequest;
