/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.MediaDrm
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.MediaDrm
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html}
 **/
var MediaDrm = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.MediaDrm')) {
		result = arguments[0];
	}
	else {
		result = MediaDrm.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MediaDrm.prototype = Object.create(SuperClass.prototype);
MediaDrm.prototype.constructor = MediaDrm;

Object.defineProperty(MediaDrm.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MediaDrm(this.$native.super);
	},
	enumerable: true
});

MediaDrm.className = 'android.media.MediaDrm';
MediaDrm.prototype.className = 'android.media.MediaDrm';

// class property
Object.defineProperty(MediaDrm, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.MediaDrm');
	},
	enumerable: true,
	configurable: false
});


// Cast
MediaDrm.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MediaDrm(Hyperloop.cast('android.media.MediaDrm', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#EVENT_KEY_REQUIRED}
 */
MediaDrm.EVENT_KEY_REQUIRED = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#EVENT_VENDOR_DEFINED}
 */
MediaDrm.EVENT_VENDOR_DEFINED = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#PROPERTY_VENDOR}
 */
MediaDrm.PROPERTY_VENDOR = "vendor";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#KEY_TYPE_OFFLINE}
 */
MediaDrm.KEY_TYPE_OFFLINE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#EVENT_SESSION_RECLAIMED}
 */
MediaDrm.EVENT_SESSION_RECLAIMED = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#KEY_TYPE_RELEASE}
 */
MediaDrm.KEY_TYPE_RELEASE = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#KEY_TYPE_STREAMING}
 */
MediaDrm.KEY_TYPE_STREAMING = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#PROPERTY_DESCRIPTION}
 */
MediaDrm.PROPERTY_DESCRIPTION = "description";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#EVENT_KEY_EXPIRED}
 */
MediaDrm.EVENT_KEY_EXPIRED = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#EVENT_PROVISION_REQUIRED}
 */
MediaDrm.EVENT_PROVISION_REQUIRED = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#PROPERTY_ALGORITHMS}
 */
MediaDrm.PROPERTY_ALGORITHMS = "algorithms";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#PROPERTY_VERSION}
 */
MediaDrm.PROPERTY_VERSION = "version";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#PROPERTY_DEVICE_UNIQUE_ID}
 */
MediaDrm.PROPERTY_DEVICE_UNIQUE_ID = "deviceUniqueId";

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function isCryptoSchemeSupported
 * @static
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#isCryptoSchemeSupported(java.util.UUID)}
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#isCryptoSchemeSupported(java.util.UUID, java.lang.String)}
 **/
MediaDrm.isCryptoSchemeSupported = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isCryptoSchemeSupported',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setPropertyString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#setPropertyString(java.lang.String, java.lang.String)}
 **/
MediaDrm.prototype.setPropertyString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPropertyString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function restoreKeys
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#restoreKeys(byte[], byte[])}
 **/
MediaDrm.prototype.restoreKeys = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'restoreKeys',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function provideProvisionResponse
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#provideProvisionResponse(byte[])}
 **/
MediaDrm.prototype.provideProvisionResponse = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'provideProvisionResponse',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSecureStop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#getSecureStop(byte[])}
 **/
MediaDrm.prototype.getSecureStop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSecureStop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function release
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#release()}
 **/
MediaDrm.prototype.release = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'release',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function releaseSecureStops
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#releaseSecureStops(byte[])}
 **/
MediaDrm.prototype.releaseSecureStops = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'releaseSecureStops',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function releaseAllSecureStops
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#releaseAllSecureStops()}
 **/
MediaDrm.prototype.releaseAllSecureStops = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'releaseAllSecureStops',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnExpirationUpdateListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#setOnExpirationUpdateListener(android.media.MediaDrm$OnExpirationUpdateListener, android.os.Handler)}
 **/
MediaDrm.prototype.setOnExpirationUpdateListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnExpirationUpdateListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getKeyRequest
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#getKeyRequest(byte[], byte[], java.lang.String, int, java.util.HashMap)}
 **/
MediaDrm.prototype.getKeyRequest = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getKeyRequest',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSecureStops
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#getSecureStops()}
 **/
MediaDrm.prototype.getSecureStops = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSecureStops',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCryptoSession
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#getCryptoSession(byte[], java.lang.String, java.lang.String)}
 **/
MediaDrm.prototype.getCryptoSession = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCryptoSession',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function closeSession
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#closeSession(byte[])}
 **/
MediaDrm.prototype.closeSession = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'closeSession',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function queryKeyStatus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#queryKeyStatus(byte[])}
 **/
MediaDrm.prototype.queryKeyStatus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'queryKeyStatus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnKeyStatusChangeListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#setOnKeyStatusChangeListener(android.media.MediaDrm$OnKeyStatusChangeListener, android.os.Handler)}
 **/
MediaDrm.prototype.setOnKeyStatusChangeListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnKeyStatusChangeListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function provideKeyResponse
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#provideKeyResponse(byte[], byte[])}
 **/
MediaDrm.prototype.provideKeyResponse = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'provideKeyResponse',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPropertyString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#getPropertyString(java.lang.String)}
 **/
MediaDrm.prototype.getPropertyString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPropertyString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getProvisionRequest
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#getProvisionRequest()}
 **/
MediaDrm.prototype.getProvisionRequest = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getProvisionRequest',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeKeys
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#removeKeys(byte[])}
 **/
MediaDrm.prototype.removeKeys = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeKeys',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnEventListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#setOnEventListener(android.media.MediaDrm$OnEventListener)}
 **/
MediaDrm.prototype.setOnEventListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnEventListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setPropertyByteArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#setPropertyByteArray(java.lang.String, byte[])}
 **/
MediaDrm.prototype.setPropertyByteArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPropertyByteArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPropertyByteArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#getPropertyByteArray(java.lang.String)}
 **/
MediaDrm.prototype.getPropertyByteArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPropertyByteArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function openSession
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#openSession()}
 **/
MediaDrm.prototype.openSession = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'openSession',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function finalize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaDrm.html#finalize()}
 **/
MediaDrm.prototype.finalize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'finalize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaDrm') {
			return new MediaDrm(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MediaDrm;
