/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.MediaFormat
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.MediaFormat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html}
 **/
var MediaFormat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.MediaFormat')) {
		result = arguments[0];
	}
	else {
		result = MediaFormat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MediaFormat.prototype = Object.create(SuperClass.prototype);
MediaFormat.prototype.constructor = MediaFormat;

Object.defineProperty(MediaFormat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MediaFormat(this.$native.super);
	},
	enumerable: true
});

MediaFormat.className = 'android.media.MediaFormat';
MediaFormat.prototype.className = 'android.media.MediaFormat';

// class property
Object.defineProperty(MediaFormat, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.MediaFormat');
	},
	enumerable: true,
	configurable: false
});


// Cast
MediaFormat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MediaFormat(Hyperloop.cast('android.media.MediaFormat', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_FLAC_COMPRESSION_LEVEL}
 */
MediaFormat.KEY_FLAC_COMPRESSION_LEVEL = "flac-compression-level";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_AAC_MAX_OUTPUT_CHANNEL_COUNT}
 */
MediaFormat.KEY_AAC_MAX_OUTPUT_CHANNEL_COUNT = "aac-max-output-channel_count";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_MAX_HEIGHT}
 */
MediaFormat.KEY_MAX_HEIGHT = "max-height";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_RANGE_FULL}
 */
MediaFormat.COLOR_RANGE_FULL = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_OPUS}
 */
MediaFormat.MIMETYPE_AUDIO_OPUS = "audio/opus";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_PROFILE}
 */
MediaFormat.KEY_PROFILE = "profile";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_VORBIS}
 */
MediaFormat.MIMETYPE_AUDIO_VORBIS = "audio/vorbis";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_TEMPORAL_LAYERING}
 */
MediaFormat.KEY_TEMPORAL_LAYERING = "ts-schema";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_DURATION}
 */
MediaFormat.KEY_DURATION = "durationUs";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_OPERATING_RATE}
 */
MediaFormat.KEY_OPERATING_RATE = "operating-rate";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_SAMPLE_RATE}
 */
MediaFormat.KEY_SAMPLE_RATE = "sample-rate";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_AAC_SBR_MODE}
 */
MediaFormat.KEY_AAC_SBR_MODE = "aac-sbr-mode";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_AVC}
 */
MediaFormat.MIMETYPE_VIDEO_AVC = "video/avc";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_G711_ALAW}
 */
MediaFormat.MIMETYPE_AUDIO_G711_ALAW = "audio/g711-alaw";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_RAW}
 */
MediaFormat.MIMETYPE_AUDIO_RAW = "audio/raw";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_MAX_WIDTH}
 */
MediaFormat.KEY_MAX_WIDTH = "max-width";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_G711_MLAW}
 */
MediaFormat.MIMETYPE_AUDIO_G711_MLAW = "audio/g711-mlaw";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_IS_ADTS}
 */
MediaFormat.KEY_IS_ADTS = "is-adts";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_CHANNEL_COUNT}
 */
MediaFormat.KEY_CHANNEL_COUNT = "channel-count";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_INTRA_REFRESH_PERIOD}
 */
MediaFormat.KEY_INTRA_REFRESH_PERIOD = "intra-refresh-period";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_PCM_ENCODING}
 */
MediaFormat.KEY_PCM_ENCODING = "pcm-encoding";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_BITRATE_MODE}
 */
MediaFormat.KEY_BITRATE_MODE = "bitrate-mode";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_ROTATION}
 */
MediaFormat.KEY_ROTATION = "rotation-degrees";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_AMR_NB}
 */
MediaFormat.MIMETYPE_AUDIO_AMR_NB = "audio/3gpp";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_TEXT_CEA_608}
 */
MediaFormat.MIMETYPE_TEXT_CEA_608 = "text/cea-608";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_QCELP}
 */
MediaFormat.MIMETYPE_AUDIO_QCELP = "audio/qcelp";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_AMR_WB}
 */
MediaFormat.MIMETYPE_AUDIO_AMR_WB = "audio/amr-wb";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_TEXT_VTT}
 */
MediaFormat.MIMETYPE_TEXT_VTT = "text/vtt";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_MAX_INPUT_SIZE}
 */
MediaFormat.KEY_MAX_INPUT_SIZE = "max-input-size";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_STANDARD_BT601_NTSC}
 */
MediaFormat.COLOR_STANDARD_BT601_NTSC = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_AAC_DRC_ATTENUATION_FACTOR}
 */
MediaFormat.KEY_AAC_DRC_ATTENUATION_FACTOR = "aac-drc-cut-level";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_H263}
 */
MediaFormat.MIMETYPE_VIDEO_H263 = "video/3gpp";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_AAC_DRC_BOOST_FACTOR}
 */
MediaFormat.KEY_AAC_DRC_BOOST_FACTOR = "aac-drc-boost-level";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_COLOR_TRANSFER}
 */
MediaFormat.KEY_COLOR_TRANSFER = "color-transfer";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_HDR_STATIC_INFO}
 */
MediaFormat.KEY_HDR_STATIC_INFO = "hdr-static-info";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_RAW}
 */
MediaFormat.MIMETYPE_VIDEO_RAW = "video/raw";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_AUDIO_SESSION_ID}
 */
MediaFormat.KEY_AUDIO_SESSION_ID = "audio-session-id";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_AC3}
 */
MediaFormat.MIMETYPE_AUDIO_AC3 = "audio/ac3";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_STANDARD_BT2020}
 */
MediaFormat.COLOR_STANDARD_BT2020 = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_AAC_DRC_HEAVY_COMPRESSION}
 */
MediaFormat.KEY_AAC_DRC_HEAVY_COMPRESSION = "aac-drc-heavy-compression";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_PUSH_BLANK_BUFFERS_ON_STOP}
 */
MediaFormat.KEY_PUSH_BLANK_BUFFERS_ON_STOP = "push-blank-buffers-on-shutdown";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_SLICE_HEIGHT}
 */
MediaFormat.KEY_SLICE_HEIGHT = "slice-height";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_EAC3}
 */
MediaFormat.MIMETYPE_AUDIO_EAC3 = "audio/eac3";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_STANDARD_BT601_PAL}
 */
MediaFormat.COLOR_STANDARD_BT601_PAL = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_LANGUAGE}
 */
MediaFormat.KEY_LANGUAGE = "language";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_SCRAMBLED}
 */
MediaFormat.MIMETYPE_AUDIO_SCRAMBLED = "audio/scrambled";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_STRIDE}
 */
MediaFormat.KEY_STRIDE = "stride";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_FLAC}
 */
MediaFormat.MIMETYPE_AUDIO_FLAC = "audio/flac";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_MPEG}
 */
MediaFormat.MIMETYPE_AUDIO_MPEG = "audio/mpeg";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_LEVEL}
 */
MediaFormat.KEY_LEVEL = "level";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_TRANSFER_ST2084}
 */
MediaFormat.COLOR_TRANSFER_ST2084 = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_TRACK_ID}
 */
MediaFormat.KEY_TRACK_ID = "track-id";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_RANGE_LIMITED}
 */
MediaFormat.COLOR_RANGE_LIMITED = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_IS_FORCED_SUBTITLE}
 */
MediaFormat.KEY_IS_FORCED_SUBTITLE = "is-forced-subtitle";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_DOLBY_VISION}
 */
MediaFormat.MIMETYPE_VIDEO_DOLBY_VISION = "video/dolby-vision";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_AAC_DRC_TARGET_REFERENCE_LEVEL}
 */
MediaFormat.KEY_AAC_DRC_TARGET_REFERENCE_LEVEL = "aac-target-ref-level";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_MPEG2}
 */
MediaFormat.MIMETYPE_VIDEO_MPEG2 = "video/mpeg2";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_TRANSFER_SDR_VIDEO}
 */
MediaFormat.COLOR_TRANSFER_SDR_VIDEO = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_MPEG4}
 */
MediaFormat.MIMETYPE_VIDEO_MPEG4 = "video/mp4v-es";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_I_FRAME_INTERVAL}
 */
MediaFormat.KEY_I_FRAME_INTERVAL = "i-frame-interval";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_TRANSFER_HLG}
 */
MediaFormat.COLOR_TRANSFER_HLG = 7;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_HEIGHT}
 */
MediaFormat.KEY_HEIGHT = "height";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_TRANSFER_LINEAR}
 */
MediaFormat.COLOR_TRANSFER_LINEAR = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_MSGSM}
 */
MediaFormat.MIMETYPE_AUDIO_MSGSM = "audio/gsm";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_SCRAMBLED}
 */
MediaFormat.MIMETYPE_VIDEO_SCRAMBLED = "video/scrambled";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_FRAME_RATE}
 */
MediaFormat.KEY_FRAME_RATE = "frame-rate";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_VP9}
 */
MediaFormat.MIMETYPE_VIDEO_VP9 = "video/x-vnd.on2.vp9";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_VP8}
 */
MediaFormat.MIMETYPE_VIDEO_VP8 = "video/x-vnd.on2.vp8";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#COLOR_STANDARD_BT709}
 */
MediaFormat.COLOR_STANDARD_BT709 = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_AAC_ENCODED_TARGET_LEVEL}
 */
MediaFormat.KEY_AAC_ENCODED_TARGET_LEVEL = "aac-encoded-target-level";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_COLOR_FORMAT}
 */
MediaFormat.KEY_COLOR_FORMAT = "color-format";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_CAPTURE_RATE}
 */
MediaFormat.KEY_CAPTURE_RATE = "capture-rate";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_CHANNEL_MASK}
 */
MediaFormat.KEY_CHANNEL_MASK = "channel-mask";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_COMPLEXITY}
 */
MediaFormat.KEY_COMPLEXITY = "complexity";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_REPEAT_PREVIOUS_FRAME_AFTER}
 */
MediaFormat.KEY_REPEAT_PREVIOUS_FRAME_AFTER = "repeat-previous-frame-after";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_PRIORITY}
 */
MediaFormat.KEY_PRIORITY = "priority";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_MIME}
 */
MediaFormat.KEY_MIME = "mime";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_LATENCY}
 */
MediaFormat.KEY_LATENCY = "latency";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_WIDTH}
 */
MediaFormat.KEY_WIDTH = "width";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_IS_DEFAULT}
 */
MediaFormat.KEY_IS_DEFAULT = "is-default";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_COLOR_RANGE}
 */
MediaFormat.KEY_COLOR_RANGE = "color-range";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_VIDEO_HEVC}
 */
MediaFormat.MIMETYPE_VIDEO_HEVC = "video/hevc";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#MIMETYPE_AUDIO_AAC}
 */
MediaFormat.MIMETYPE_AUDIO_AAC = "audio/mp4a-latm";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_BIT_RATE}
 */
MediaFormat.KEY_BIT_RATE = "bitrate";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_COLOR_STANDARD}
 */
MediaFormat.KEY_COLOR_STANDARD = "color-standard";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_IS_AUTOSELECT}
 */
MediaFormat.KEY_IS_AUTOSELECT = "is-autoselect";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#KEY_AAC_PROFILE}
 */
MediaFormat.KEY_AAC_PROFILE = "aac-profile";

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function createVideoFormat
 * @static
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#createVideoFormat(java.lang.String, int, int)}
 **/
MediaFormat.createVideoFormat = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createVideoFormat',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createAudioFormat
 * @static
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#createAudioFormat(java.lang.String, int, int)}
 **/
MediaFormat.createAudioFormat = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createAudioFormat',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createSubtitleFormat
 * @static
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#createSubtitleFormat(java.lang.String, java.lang.String)}
 **/
MediaFormat.createSubtitleFormat = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createSubtitleFormat',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getFeatureEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#getFeatureEnabled(java.lang.String)}
 **/
MediaFormat.prototype.getFeatureEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFeatureEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFloat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#setFloat(java.lang.String, float)}
 **/
MediaFormat.prototype.setFloat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFloat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function containsKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#containsKey(java.lang.String)}
 **/
MediaFormat.prototype.containsKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'containsKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setInteger
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#setInteger(java.lang.String, int)}
 **/
MediaFormat.prototype.setInteger = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setInteger',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInteger
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#getInteger(java.lang.String)}
 **/
MediaFormat.prototype.getInteger = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInteger',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getByteBuffer
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#getByteBuffer(java.lang.String)}
 **/
MediaFormat.prototype.getByteBuffer = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getByteBuffer',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFloat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#getFloat(java.lang.String)}
 **/
MediaFormat.prototype.getFloat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFloat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#getString(java.lang.String)}
 **/
MediaFormat.prototype.getString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#getLong(java.lang.String)}
 **/
MediaFormat.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#setLong(java.lang.String, long)}
 **/
MediaFormat.prototype.setLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#setString(java.lang.String, java.lang.String)}
 **/
MediaFormat.prototype.setString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setByteBuffer
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#setByteBuffer(java.lang.String, java.nio.ByteBuffer)}
 **/
MediaFormat.prototype.setByteBuffer = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setByteBuffer',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFeatureEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#setFeatureEnabled(java.lang.String, boolean)}
 **/
MediaFormat.prototype.setFeatureEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFeatureEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaFormat.html#toString()}
 **/
MediaFormat.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaFormat') {
			return new MediaFormat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MediaFormat;
