/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.TimedMetaData
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.TimedMetaData
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/TimedMetaData.html}
 **/
var TimedMetaData = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.TimedMetaData')) {
		result = arguments[0];
	}
	else {
		result = TimedMetaData.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TimedMetaData.prototype = Object.create(SuperClass.prototype);
TimedMetaData.prototype.constructor = TimedMetaData;

Object.defineProperty(TimedMetaData.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TimedMetaData(this.$native.super);
	},
	enumerable: true
});

TimedMetaData.className = 'android.media.TimedMetaData';
TimedMetaData.prototype.className = 'android.media.TimedMetaData';

// class property
Object.defineProperty(TimedMetaData, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.TimedMetaData');
	},
	enumerable: true,
	configurable: false
});


// Cast
TimedMetaData.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TimedMetaData(Hyperloop.cast('android.media.TimedMetaData', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getTimestamp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/TimedMetaData.html#getTimestamp()}
 **/
TimedMetaData.prototype.getTimestamp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTimestamp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.TimedMetaData') {
			return new TimedMetaData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMetaData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/TimedMetaData.html#getMetaData()}
 **/
TimedMetaData.prototype.getMetaData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMetaData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.TimedMetaData') {
			return new TimedMetaData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TimedMetaData;
