/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.TimedText
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.TimedText
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/TimedText.html}
 **/
var TimedText = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.TimedText')) {
		result = arguments[0];
	}
	else {
		result = TimedText.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TimedText.prototype = Object.create(SuperClass.prototype);
TimedText.prototype.constructor = TimedText;

Object.defineProperty(TimedText.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TimedText(this.$native.super);
	},
	enumerable: true
});

TimedText.className = 'android.media.TimedText';
TimedText.prototype.className = 'android.media.TimedText';

// class property
Object.defineProperty(TimedText, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.TimedText');
	},
	enumerable: true,
	configurable: false
});


// Cast
TimedText.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TimedText(Hyperloop.cast('android.media.TimedText', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/TimedText.html#getText()}
 **/
TimedText.prototype.getText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.TimedText') {
			return new TimedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/TimedText.html#getBounds()}
 **/
TimedText.prototype.getBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.TimedText') {
			return new TimedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TimedText;
