/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.VolumeShaper$Configuration
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.media.VolumeShaper');

/**
 * @class android.media.VolumeShaper$Configuration
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html}
 **/
var Configuration = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.VolumeShaper$Configuration')) {
		result = arguments[0];
	}
	else {
		result = Configuration.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Configuration.prototype = Object.create(SuperClass.prototype);
Configuration.prototype.constructor = Configuration;

Object.defineProperty(Configuration.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Configuration(this.$native.super);
	},
	enumerable: true
});

Configuration.className = 'android.media.VolumeShaper$Configuration';
Configuration.prototype.className = 'android.media.VolumeShaper$Configuration';

// class property
Object.defineProperty(Configuration, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.VolumeShaper$Configuration');
	},
	enumerable: true,
	configurable: false
});


// Cast
Configuration.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Configuration(Hyperloop.cast('android.media.VolumeShaper$Configuration', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#INTERPOLATOR_TYPE_STEP}
 */
Configuration.INTERPOLATOR_TYPE_STEP = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#INTERPOLATOR_TYPE_CUBIC}
 */
Configuration.INTERPOLATOR_TYPE_CUBIC = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#INTERPOLATOR_TYPE_CUBIC_MONOTONIC}
 */
Configuration.INTERPOLATOR_TYPE_CUBIC_MONOTONIC = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#INTERPOLATOR_TYPE_LINEAR}
 */
Configuration.INTERPOLATOR_TYPE_LINEAR = 1;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#CREATOR
Object.defineProperty(Configuration, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.VolumeShaper$Configuration') {
				return new Configuration(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#LINEAR_RAMP
Object.defineProperty(Configuration, 'LINEAR_RAMP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('LINEAR_RAMP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.VolumeShaper$Configuration') {
				return new Configuration(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#SCURVE_RAMP
Object.defineProperty(Configuration, 'SCURVE_RAMP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SCURVE_RAMP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.VolumeShaper$Configuration') {
				return new Configuration(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#CUBIC_RAMP
Object.defineProperty(Configuration, 'CUBIC_RAMP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CUBIC_RAMP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.VolumeShaper$Configuration') {
				return new Configuration(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#SINE_RAMP
Object.defineProperty(Configuration, 'SINE_RAMP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SINE_RAMP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.VolumeShaper$Configuration') {
				return new Configuration(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getMaximumCurvePoints
 * @static
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#getMaximumCurvePoints()}
 **/
Configuration.getMaximumCurvePoints = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getMaximumCurvePoints',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getTimes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#getTimes()}
 **/
Configuration.prototype.getTimes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTimes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#getDuration()}
 **/
Configuration.prototype.getDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInterpolatorType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#getInterpolatorType()}
 **/
Configuration.prototype.getInterpolatorType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInterpolatorType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#hashCode()}
 **/
Configuration.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#equals(java.lang.Object)}
 **/
Configuration.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#toString()}
 **/
Configuration.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getVolumes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#getVolumes()}
 **/
Configuration.prototype.getVolumes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getVolumes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#describeContents()}
 **/
Configuration.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Configuration.html#writeToParcel(android.os.Parcel, int)}
 **/
Configuration.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Configuration') {
			return new Configuration(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Configuration;
