/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.VolumeShaper$Operation
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.media.VolumeShaper');

/**
 * @class android.media.VolumeShaper$Operation
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Operation.html}
 **/
var Operation = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.VolumeShaper$Operation')) {
		result = arguments[0];
	}
	else {
		result = Operation.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Operation.prototype = Object.create(SuperClass.prototype);
Operation.prototype.constructor = Operation;

Object.defineProperty(Operation.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Operation(this.$native.super);
	},
	enumerable: true
});

Operation.className = 'android.media.VolumeShaper$Operation';
Operation.prototype.className = 'android.media.VolumeShaper$Operation';

// class property
Object.defineProperty(Operation, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.VolumeShaper$Operation');
	},
	enumerable: true,
	configurable: false
});


// Cast
Operation.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Operation(Hyperloop.cast('android.media.VolumeShaper$Operation', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/media/VolumeShaper.Operation.html#PLAY
Object.defineProperty(Operation, 'PLAY', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('PLAY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.VolumeShaper$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/media/VolumeShaper.Operation.html#CREATOR
Object.defineProperty(Operation, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.VolumeShaper$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/media/VolumeShaper.Operation.html#REVERSE
Object.defineProperty(Operation, 'REVERSE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('REVERSE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.VolumeShaper$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Operation.html#hashCode()}
 **/
Operation.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Operation') {
			return new Operation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Operation.html#equals(java.lang.Object)}
 **/
Operation.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Operation') {
			return new Operation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Operation.html#toString()}
 **/
Operation.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Operation') {
			return new Operation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Operation.html#describeContents()}
 **/
Operation.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Operation') {
			return new Operation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.Operation.html#writeToParcel(android.os.Parcel, int)}
 **/
Operation.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper$Operation') {
			return new Operation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Operation;
