/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.SurfaceView
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * @class android.view.SurfaceView
 * @extends android.view.View 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html}
 **/
var SurfaceView = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.SurfaceView')) {
		result = arguments[0];
	}
	else {
		result = SurfaceView.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.view.View');
SurfaceView.prototype = Object.create(SuperClass.prototype);
SurfaceView.prototype.constructor = SurfaceView;

Object.defineProperty(SurfaceView.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new SurfaceView(this.$native.super);
	},
	enumerable: true
});

SurfaceView.className = 'android.view.SurfaceView';
SurfaceView.prototype.className = 'android.view.SurfaceView';

// class property
Object.defineProperty(SurfaceView, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.SurfaceView');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
SurfaceView.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.SurfaceView');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(SurfaceView.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
SurfaceView.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new SurfaceView(Hyperloop.cast('android.view.SurfaceView', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setZOrderMediaOverlay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#setZOrderMediaOverlay(boolean)}
 **/
SurfaceView.prototype.setZOrderMediaOverlay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setZOrderMediaOverlay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onWindowVisibilityChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#onWindowVisibilityChanged(int)}
 **/
SurfaceView.prototype.onWindowVisibilityChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onWindowVisibilityChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function draw
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#draw(android.graphics.Canvas)}
 **/
SurfaceView.prototype.draw = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'draw',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMeasure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#onMeasure(int, int)}
 **/
SurfaceView.prototype.onMeasure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMeasure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setVisibility
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#setVisibility(int)}
 **/
SurfaceView.prototype.setVisibility = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setVisibility',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchDraw
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#dispatchDraw(android.graphics.Canvas)}
 **/
SurfaceView.prototype.dispatchDraw = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchDraw',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function gatherTransparentRegion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#gatherTransparentRegion(android.graphics.Region)}
 **/
SurfaceView.prototype.gatherTransparentRegion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'gatherTransparentRegion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setZOrderOnTop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#setZOrderOnTop(boolean)}
 **/
SurfaceView.prototype.setZOrderOnTop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setZOrderOnTop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDetachedFromWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#onDetachedFromWindow()}
 **/
SurfaceView.prototype.onDetachedFromWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDetachedFromWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAttachedToWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#onAttachedToWindow()}
 **/
SurfaceView.prototype.onAttachedToWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAttachedToWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSecure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#setSecure(boolean)}
 **/
SurfaceView.prototype.setSecure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSecure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getHolder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/SurfaceView.html#getHolder()}
 **/
SurfaceView.prototype.getHolder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHolder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.SurfaceView') {
			return new SurfaceView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = SurfaceView;
