/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.MediaPlayer$MetricsConstants
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.media.MediaPlayer');

/**
 * @class android.media.MediaPlayer$MetricsConstants
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html}
 **/
var MetricsConstants = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.MediaPlayer$MetricsConstants')) {
		result = arguments[0];
	}
	else {
		result = MetricsConstants.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MetricsConstants.prototype = Object.create(SuperClass.prototype);
MetricsConstants.prototype.constructor = MetricsConstants;

Object.defineProperty(MetricsConstants.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MetricsConstants(this.$native.super);
	},
	enumerable: true
});

MetricsConstants.className = 'android.media.MediaPlayer$MetricsConstants';
MetricsConstants.prototype.className = 'android.media.MediaPlayer$MetricsConstants';

// class property
Object.defineProperty(MetricsConstants, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.MediaPlayer$MetricsConstants');
	},
	enumerable: true,
	configurable: false
});


// Cast
MetricsConstants.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MetricsConstants(Hyperloop.cast('android.media.MediaPlayer$MetricsConstants', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#CODEC_AUDIO}
 */
MetricsConstants.CODEC_AUDIO = "android.media.mediaplayer.audio.codec";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#MIME_TYPE_VIDEO}
 */
MetricsConstants.MIME_TYPE_VIDEO = "android.media.mediaplayer.video.mime";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#MIME_TYPE_AUDIO}
 */
MetricsConstants.MIME_TYPE_AUDIO = "android.media.mediaplayer.audio.mime";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#ERRORS}
 */
MetricsConstants.ERRORS = "android.media.mediaplayer.err";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#FRAMES}
 */
MetricsConstants.FRAMES = "android.media.mediaplayer.frames";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#FRAMES_DROPPED}
 */
MetricsConstants.FRAMES_DROPPED = "android.media.mediaplayer.dropped";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#WIDTH}
 */
MetricsConstants.WIDTH = "android.media.mediaplayer.width";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#HEIGHT}
 */
MetricsConstants.HEIGHT = "android.media.mediaplayer.height";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#CODEC_VIDEO}
 */
MetricsConstants.CODEC_VIDEO = "android.media.mediaplayer.video.codec";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#DURATION}
 */
MetricsConstants.DURATION = "android.media.mediaplayer.durationMs";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#PLAYING}
 */
MetricsConstants.PLAYING = "android.media.mediaplayer.playingMs";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.MetricsConstants.html#ERROR_CODE}
 */
MetricsConstants.ERROR_CODE = "android.media.mediaplayer.errcode";

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods

// export the class
module.exports = MetricsConstants;
