/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.MediaPlayer$TrackInfo
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.media.MediaPlayer');

/**
 * @class android.media.MediaPlayer$TrackInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html}
 **/
var TrackInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.MediaPlayer$TrackInfo')) {
		result = arguments[0];
	}
	else {
		result = TrackInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TrackInfo.prototype = Object.create(SuperClass.prototype);
TrackInfo.prototype.constructor = TrackInfo;

Object.defineProperty(TrackInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TrackInfo(this.$native.super);
	},
	enumerable: true
});

TrackInfo.className = 'android.media.MediaPlayer$TrackInfo';
TrackInfo.prototype.className = 'android.media.MediaPlayer$TrackInfo';

// class property
Object.defineProperty(TrackInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.MediaPlayer$TrackInfo');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TrackInfo.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.media.MediaPlayer$TrackInfo');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TrackInfo.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TrackInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TrackInfo(Hyperloop.cast('android.media.MediaPlayer$TrackInfo', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#MEDIA_TRACK_TYPE_UNKNOWN}
 */
TrackInfo.MEDIA_TRACK_TYPE_UNKNOWN = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#MEDIA_TRACK_TYPE_SUBTITLE}
 */
TrackInfo.MEDIA_TRACK_TYPE_SUBTITLE = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#MEDIA_TRACK_TYPE_TIMEDTEXT}
 */
TrackInfo.MEDIA_TRACK_TYPE_TIMEDTEXT = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#MEDIA_TRACK_TYPE_VIDEO}
 */
TrackInfo.MEDIA_TRACK_TYPE_VIDEO = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#MEDIA_TRACK_TYPE_AUDIO}
 */
TrackInfo.MEDIA_TRACK_TYPE_AUDIO = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#MEDIA_TRACK_TYPE_METADATA}
 */
TrackInfo.MEDIA_TRACK_TYPE_METADATA = 5;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getTrackType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#getTrackType()}
 **/
TrackInfo.prototype.getTrackType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTrackType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer$TrackInfo') {
			return new TrackInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLanguage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#getLanguage()}
 **/
TrackInfo.prototype.getLanguage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLanguage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer$TrackInfo') {
			return new TrackInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFormat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#getFormat()}
 **/
TrackInfo.prototype.getFormat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFormat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer$TrackInfo') {
			return new TrackInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#toString()}
 **/
TrackInfo.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer$TrackInfo') {
			return new TrackInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#describeContents()}
 **/
TrackInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer$TrackInfo') {
			return new TrackInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.TrackInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
TrackInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer$TrackInfo') {
			return new TrackInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TrackInfo;
