/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.MediaPlayer
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.MediaPlayer
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html}
 **/
var MediaPlayer = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.MediaPlayer')) {
		result = arguments[0];
	}
	else {
		result = MediaPlayer.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MediaPlayer.prototype = Object.create(SuperClass.prototype);
MediaPlayer.prototype.constructor = MediaPlayer;

Object.defineProperty(MediaPlayer.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MediaPlayer(this.$native.super);
	},
	enumerable: true
});

MediaPlayer.className = 'android.media.MediaPlayer';
MediaPlayer.prototype.className = 'android.media.MediaPlayer';

// class property
Object.defineProperty(MediaPlayer, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.MediaPlayer');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
MediaPlayer.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.media.MediaPlayer');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(MediaPlayer.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
MediaPlayer.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MediaPlayer(Hyperloop.cast('android.media.MediaPlayer', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_NOT_SEEKABLE}
 */
MediaPlayer.MEDIA_INFO_NOT_SEEKABLE = 801;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING}
 */
MediaPlayer.VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#SEEK_PREVIOUS_SYNC}
 */
MediaPlayer.SEEK_PREVIOUS_SYNC = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#VIDEO_SCALING_MODE_SCALE_TO_FIT}
 */
MediaPlayer.VIDEO_SCALING_MODE_SCALE_TO_FIT = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_SUBTITLE_TIMED_OUT}
 */
MediaPlayer.MEDIA_INFO_SUBTITLE_TIMED_OUT = 902;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_ERROR_MALFORMED}
 */
MediaPlayer.MEDIA_ERROR_MALFORMED = -1007;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_MIMETYPE_TEXT_SUBRIP}
 */
MediaPlayer.MEDIA_MIMETYPE_TEXT_SUBRIP = "application/x-subrip";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#PREPARE_DRM_STATUS_SUCCESS}
 */
MediaPlayer.PREPARE_DRM_STATUS_SUCCESS = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_ERROR_NOT_VALID_FOR_PROGRESSIVE_PLAYBACK}
 */
MediaPlayer.MEDIA_ERROR_NOT_VALID_FOR_PROGRESSIVE_PLAYBACK = 200;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#PREPARE_DRM_STATUS_PROVISIONING_NETWORK_ERROR}
 */
MediaPlayer.PREPARE_DRM_STATUS_PROVISIONING_NETWORK_ERROR = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_ERROR_SERVER_DIED}
 */
MediaPlayer.MEDIA_ERROR_SERVER_DIED = 100;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_BAD_INTERLEAVING}
 */
MediaPlayer.MEDIA_INFO_BAD_INTERLEAVING = 800;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_BUFFERING_END}
 */
MediaPlayer.MEDIA_INFO_BUFFERING_END = 702;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_UNKNOWN}
 */
MediaPlayer.MEDIA_INFO_UNKNOWN = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_ERROR_UNKNOWN}
 */
MediaPlayer.MEDIA_ERROR_UNKNOWN = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_VIDEO_NOT_PLAYING}
 */
MediaPlayer.MEDIA_INFO_VIDEO_NOT_PLAYING = 805;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#PREPARE_DRM_STATUS_PREPARATION_ERROR}
 */
MediaPlayer.PREPARE_DRM_STATUS_PREPARATION_ERROR = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_VIDEO_TRACK_LAGGING}
 */
MediaPlayer.MEDIA_INFO_VIDEO_TRACK_LAGGING = 700;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#SEEK_CLOSEST}
 */
MediaPlayer.SEEK_CLOSEST = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#SEEK_NEXT_SYNC}
 */
MediaPlayer.SEEK_NEXT_SYNC = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#SEEK_CLOSEST_SYNC}
 */
MediaPlayer.SEEK_CLOSEST_SYNC = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_AUDIO_NOT_PLAYING}
 */
MediaPlayer.MEDIA_INFO_AUDIO_NOT_PLAYING = 804;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_ERROR_IO}
 */
MediaPlayer.MEDIA_ERROR_IO = -1004;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_BUFFERING_START}
 */
MediaPlayer.MEDIA_INFO_BUFFERING_START = 701;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_UNSUPPORTED_SUBTITLE}
 */
MediaPlayer.MEDIA_INFO_UNSUPPORTED_SUBTITLE = 901;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_METADATA_UPDATE}
 */
MediaPlayer.MEDIA_INFO_METADATA_UPDATE = 802;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#PREPARE_DRM_STATUS_PROVISIONING_SERVER_ERROR}
 */
MediaPlayer.PREPARE_DRM_STATUS_PROVISIONING_SERVER_ERROR = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_ERROR_TIMED_OUT}
 */
MediaPlayer.MEDIA_ERROR_TIMED_OUT = -110;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_INFO_VIDEO_RENDERING_START}
 */
MediaPlayer.MEDIA_INFO_VIDEO_RENDERING_START = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#MEDIA_ERROR_UNSUPPORTED}
 */
MediaPlayer.MEDIA_ERROR_UNSUPPORTED = -1010;

// Inner classes
Object.defineProperty(MediaPlayer, 'OnTimedTextListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnTimedTextListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnBufferingUpdateListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnBufferingUpdateListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnSeekCompleteListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnSeekCompleteListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'DrmInfo', {
	get: function() {
		return require('./android.media.MediaPlayer$DrmInfo');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnTimedMetaDataAvailableListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnTimedMetaDataAvailableListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'ProvisioningServerErrorException', {
	get: function() {
		return require('./android.media.MediaPlayer$ProvisioningServerErrorException');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnDrmPreparedListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnDrmPreparedListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'NoDrmSchemeException', {
	get: function() {
		return require('./android.media.MediaPlayer$NoDrmSchemeException');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnDrmConfigHelper', {
	get: function() {
		return require('./android.media.MediaPlayer$OnDrmConfigHelper');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'MetricsConstants', {
	get: function() {
		return require('./android.media.MediaPlayer$MetricsConstants');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'ProvisioningNetworkErrorException', {
	get: function() {
		return require('./android.media.MediaPlayer$ProvisioningNetworkErrorException');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnVideoSizeChangedListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnVideoSizeChangedListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'TrackInfo', {
	get: function() {
		return require('./android.media.MediaPlayer$TrackInfo');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnPreparedListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnPreparedListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnDrmInfoListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnDrmInfoListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnCompletionListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnCompletionListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnErrorListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnErrorListener');
	},
	enumerable: true
});
Object.defineProperty(MediaPlayer, 'OnInfoListener', {
	get: function() {
		return require('./android.media.MediaPlayer$OnInfoListener');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function create
 * @static
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#create(android.content.Context, android.net.Uri)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#create(android.content.Context, android.net.Uri, android.view.SurfaceHolder)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#create(android.content.Context, android.net.Uri, android.view.SurfaceHolder, android.media.AudioAttributes, int)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#create(android.content.Context, int)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#create(android.content.Context, int, android.media.AudioAttributes, int)}
 **/
MediaPlayer.create = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'create',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function prepare
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#prepare()}
 **/
MediaPlayer.prototype.prepare = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'prepare',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnSeekCompleteListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnSeekCompleteListener(android.media.MediaPlayer$OnSeekCompleteListener)}
 **/
MediaPlayer.prototype.setOnSeekCompleteListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnSeekCompleteListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function restoreKeys
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#restoreKeys(byte[])}
 **/
MediaPlayer.prototype.restoreKeys = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'restoreKeys',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSyncParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getSyncParams()}
 **/
MediaPlayer.prototype.getSyncParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSyncParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function release
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#release()}
 **/
MediaPlayer.prototype.release = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'release',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAudioStreamType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setAudioStreamType(int)}
 **/
MediaPlayer.prototype.setAudioStreamType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAudioStreamType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setVideoScalingMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setVideoScalingMode(int)}
 **/
MediaPlayer.prototype.setVideoScalingMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setVideoScalingMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function releaseDrm
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#releaseDrm()}
 **/
MediaPlayer.prototype.releaseDrm = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'releaseDrm',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTrackInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getTrackInfo()}
 **/
MediaPlayer.prototype.getTrackInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTrackInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function deselectTrack
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#deselectTrack(int)}
 **/
MediaPlayer.prototype.deselectTrack = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'deselectTrack',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createVolumeShaper
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#createVolumeShaper(android.media.VolumeShaper$Configuration)}
 **/
MediaPlayer.prototype.createVolumeShaper = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createVolumeShaper',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getDuration()}
 **/
MediaPlayer.prototype.getDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setNextMediaPlayer
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setNextMediaPlayer(android.media.MediaPlayer)}
 **/
MediaPlayer.prototype.setNextMediaPlayer = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setNextMediaPlayer',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function selectTrack
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#selectTrack(int)}
 **/
MediaPlayer.prototype.selectTrack = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'selectTrack',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSyncParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setSyncParams(android.media.SyncParams)}
 **/
MediaPlayer.prototype.setSyncParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSyncParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnDrmPreparedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnDrmPreparedListener(android.media.MediaPlayer$OnDrmPreparedListener)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnDrmPreparedListener(android.media.MediaPlayer$OnDrmPreparedListener, android.os.Handler)}
 **/
MediaPlayer.prototype.setOnDrmPreparedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnDrmPreparedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnTimedMetaDataAvailableListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnTimedMetaDataAvailableListener(android.media.MediaPlayer$OnTimedMetaDataAvailableListener)}
 **/
MediaPlayer.prototype.setOnTimedMetaDataAvailableListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnTimedMetaDataAvailableListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnVideoSizeChangedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnVideoSizeChangedListener(android.media.MediaPlayer$OnVideoSizeChangedListener)}
 **/
MediaPlayer.prototype.setOnVideoSizeChangedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnVideoSizeChangedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isPlaying
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#isPlaying()}
 **/
MediaPlayer.prototype.isPlaying = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isPlaying',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSurface
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setSurface(android.view.Surface)}
 **/
MediaPlayer.prototype.setSurface = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSurface',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAuxEffectSendLevel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setAuxEffectSendLevel(float)}
 **/
MediaPlayer.prototype.setAuxEffectSendLevel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAuxEffectSendLevel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnDrmConfigHelper
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnDrmConfigHelper(android.media.MediaPlayer$OnDrmConfigHelper)}
 **/
MediaPlayer.prototype.setOnDrmConfigHelper = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnDrmConfigHelper',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function provideKeyResponse
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#provideKeyResponse(byte[], byte[])}
 **/
MediaPlayer.prototype.provideKeyResponse = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'provideKeyResponse',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnCompletionListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnCompletionListener(android.media.MediaPlayer$OnCompletionListener)}
 **/
MediaPlayer.prototype.setOnCompletionListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnCompletionListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAudioSessionId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getAudioSessionId()}
 **/
MediaPlayer.prototype.getAudioSessionId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAudioSessionId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setWakeMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setWakeMode(android.content.Context, int)}
 **/
MediaPlayer.prototype.setWakeMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setWakeMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setPlaybackParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setPlaybackParams(android.media.PlaybackParams)}
 **/
MediaPlayer.prototype.setPlaybackParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPlaybackParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function pause
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#pause()}
 **/
MediaPlayer.prototype.pause = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'pause',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getVideoHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getVideoHeight()}
 **/
MediaPlayer.prototype.getVideoHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getVideoHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSelectedTrack
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getSelectedTrack(int)}
 **/
MediaPlayer.prototype.getSelectedTrack = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSelectedTrack',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnErrorListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnErrorListener(android.media.MediaPlayer$OnErrorListener)}
 **/
MediaPlayer.prototype.setOnErrorListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnErrorListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAudioSessionId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setAudioSessionId(int)}
 **/
MediaPlayer.prototype.setAudioSessionId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAudioSessionId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function stop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#stop()}
 **/
MediaPlayer.prototype.stop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'stop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function reset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#reset()}
 **/
MediaPlayer.prototype.reset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDrmPropertyString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getDrmPropertyString(java.lang.String)}
 **/
MediaPlayer.prototype.getDrmPropertyString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDrmPropertyString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function prepareDrm
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#prepareDrm(java.util.UUID)}
 **/
MediaPlayer.prototype.prepareDrm = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'prepareDrm',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function prepareAsync
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#prepareAsync()}
 **/
MediaPlayer.prototype.prepareAsync = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'prepareAsync',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnPreparedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnPreparedListener(android.media.MediaPlayer$OnPreparedListener)}
 **/
MediaPlayer.prototype.setOnPreparedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnPreparedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMetrics
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getMetrics()}
 **/
MediaPlayer.prototype.getMetrics = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMetrics',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnDrmInfoListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnDrmInfoListener(android.media.MediaPlayer$OnDrmInfoListener)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnDrmInfoListener(android.media.MediaPlayer$OnDrmInfoListener, android.os.Handler)}
 **/
MediaPlayer.prototype.setOnDrmInfoListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnDrmInfoListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDrmPropertyString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDrmPropertyString(java.lang.String, java.lang.String)}
 **/
MediaPlayer.prototype.setDrmPropertyString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDrmPropertyString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCurrentPosition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getCurrentPosition()}
 **/
MediaPlayer.prototype.getCurrentPosition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrentPosition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnBufferingUpdateListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnBufferingUpdateListener(android.media.MediaPlayer$OnBufferingUpdateListener)}
 **/
MediaPlayer.prototype.setOnBufferingUpdateListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnBufferingUpdateListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnTimedTextListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnTimedTextListener(android.media.MediaPlayer$OnTimedTextListener)}
 **/
MediaPlayer.prototype.setOnTimedTextListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnTimedTextListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPlaybackParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getPlaybackParams()}
 **/
MediaPlayer.prototype.getPlaybackParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPlaybackParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getKeyRequest
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getKeyRequest(byte[], byte[], java.lang.String, int, java.util.Map)}
 **/
MediaPlayer.prototype.getKeyRequest = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getKeyRequest',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDrmInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getDrmInfo()}
 **/
MediaPlayer.prototype.getDrmInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDrmInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTimestamp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getTimestamp()}
 **/
MediaPlayer.prototype.getTimestamp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTimestamp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDataSource
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDataSource(android.content.Context, android.net.Uri)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDataSource(android.content.Context, android.net.Uri, java.util.Map, java.util.List)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDataSource(android.content.Context, android.net.Uri, java.util.Map)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDataSource(java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDataSource(android.content.res.AssetFileDescriptor)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDataSource(java.io.FileDescriptor)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDataSource(java.io.FileDescriptor, long, long)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDataSource(android.media.MediaDataSource)}
 **/
MediaPlayer.prototype.setDataSource = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDataSource',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getVideoWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#getVideoWidth()}
 **/
MediaPlayer.prototype.getVideoWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getVideoWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDisplay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setDisplay(android.view.SurfaceHolder)}
 **/
MediaPlayer.prototype.setDisplay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDisplay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAudioAttributes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setAudioAttributes(android.media.AudioAttributes)}
 **/
MediaPlayer.prototype.setAudioAttributes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAudioAttributes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLooping
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setLooping(boolean)}
 **/
MediaPlayer.prototype.setLooping = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLooping',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setScreenOnWhilePlaying
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setScreenOnWhilePlaying(boolean)}
 **/
MediaPlayer.prototype.setScreenOnWhilePlaying = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setScreenOnWhilePlaying',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function start
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#start()}
 **/
MediaPlayer.prototype.start = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'start',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addTimedTextSource
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#addTimedTextSource(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#addTimedTextSource(android.content.Context, android.net.Uri, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#addTimedTextSource(java.io.FileDescriptor, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#addTimedTextSource(java.io.FileDescriptor, long, long, java.lang.String)}
 **/
MediaPlayer.prototype.addTimedTextSource = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addTimedTextSource',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function attachAuxEffect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#attachAuxEffect(int)}
 **/
MediaPlayer.prototype.attachAuxEffect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'attachAuxEffect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setVolume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setVolume(float, float)}
 **/
MediaPlayer.prototype.setVolume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setVolume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function seekTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#seekTo(long, int)}
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#seekTo(int)}
 **/
MediaPlayer.prototype.seekTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'seekTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isLooping
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#isLooping()}
 **/
MediaPlayer.prototype.isLooping = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isLooping',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function finalize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#finalize()}
 **/
MediaPlayer.prototype.finalize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'finalize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnInfoListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaPlayer.html#setOnInfoListener(android.media.MediaPlayer$OnInfoListener)}
 **/
MediaPlayer.prototype.setOnInfoListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnInfoListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaPlayer') {
			return new MediaPlayer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MediaPlayer;
