/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.MediaTimestamp
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.MediaTimestamp
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/MediaTimestamp.html}
 **/
var MediaTimestamp = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.MediaTimestamp')) {
		result = arguments[0];
	}
	else {
		result = MediaTimestamp.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MediaTimestamp.prototype = Object.create(SuperClass.prototype);
MediaTimestamp.prototype.constructor = MediaTimestamp;

Object.defineProperty(MediaTimestamp.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MediaTimestamp(this.$native.super);
	},
	enumerable: true
});

MediaTimestamp.className = 'android.media.MediaTimestamp';
MediaTimestamp.prototype.className = 'android.media.MediaTimestamp';

// class property
Object.defineProperty(MediaTimestamp, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.MediaTimestamp');
	},
	enumerable: true,
	configurable: false
});


// Cast
MediaTimestamp.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MediaTimestamp(Hyperloop.cast('android.media.MediaTimestamp', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getAnchorMediaTimeUs
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaTimestamp.html#getAnchorMediaTimeUs()}
 **/
MediaTimestamp.prototype.getAnchorMediaTimeUs = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAnchorMediaTimeUs',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaTimestamp') {
			return new MediaTimestamp(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMediaClockRate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaTimestamp.html#getMediaClockRate()}
 **/
MediaTimestamp.prototype.getMediaClockRate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMediaClockRate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaTimestamp') {
			return new MediaTimestamp(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAnchorSytemNanoTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/MediaTimestamp.html#getAnchorSytemNanoTime()}
 **/
MediaTimestamp.prototype.getAnchorSytemNanoTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAnchorSytemNanoTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.MediaTimestamp') {
			return new MediaTimestamp(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MediaTimestamp;
