/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.PlaybackParams
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.PlaybackParams
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html}
 **/
var PlaybackParams = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.PlaybackParams')) {
		result = arguments[0];
	}
	else {
		result = PlaybackParams.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
PlaybackParams.prototype = Object.create(SuperClass.prototype);
PlaybackParams.prototype.constructor = PlaybackParams;

Object.defineProperty(PlaybackParams.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new PlaybackParams(this.$native.super);
	},
	enumerable: true
});

PlaybackParams.className = 'android.media.PlaybackParams';
PlaybackParams.prototype.className = 'android.media.PlaybackParams';

// class property
Object.defineProperty(PlaybackParams, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.PlaybackParams');
	},
	enumerable: true,
	configurable: false
});


// Cast
PlaybackParams.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new PlaybackParams(Hyperloop.cast('android.media.PlaybackParams', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#AUDIO_FALLBACK_MODE_DEFAULT}
 */
PlaybackParams.AUDIO_FALLBACK_MODE_DEFAULT = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#AUDIO_FALLBACK_MODE_MUTE}
 */
PlaybackParams.AUDIO_FALLBACK_MODE_MUTE = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#AUDIO_FALLBACK_MODE_FAIL}
 */
PlaybackParams.AUDIO_FALLBACK_MODE_FAIL = 2;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/media/PlaybackParams.html#CREATOR
Object.defineProperty(PlaybackParams, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.PlaybackParams') {
				return new PlaybackParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function allowDefaults
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#allowDefaults()}
 **/
PlaybackParams.prototype.allowDefaults = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'allowDefaults',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.PlaybackParams') {
			return new PlaybackParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSpeed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#setSpeed(float)}
 **/
PlaybackParams.prototype.setSpeed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSpeed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.PlaybackParams') {
			return new PlaybackParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAudioFallbackMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#getAudioFallbackMode()}
 **/
PlaybackParams.prototype.getAudioFallbackMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAudioFallbackMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.PlaybackParams') {
			return new PlaybackParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPitch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#getPitch()}
 **/
PlaybackParams.prototype.getPitch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPitch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.PlaybackParams') {
			return new PlaybackParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAudioFallbackMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#setAudioFallbackMode(int)}
 **/
PlaybackParams.prototype.setAudioFallbackMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAudioFallbackMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.PlaybackParams') {
			return new PlaybackParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSpeed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#getSpeed()}
 **/
PlaybackParams.prototype.getSpeed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpeed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.PlaybackParams') {
			return new PlaybackParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setPitch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#setPitch(float)}
 **/
PlaybackParams.prototype.setPitch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPitch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.PlaybackParams') {
			return new PlaybackParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#describeContents()}
 **/
PlaybackParams.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.PlaybackParams') {
			return new PlaybackParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/PlaybackParams.html#writeToParcel(android.os.Parcel, int)}
 **/
PlaybackParams.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.PlaybackParams') {
			return new PlaybackParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = PlaybackParams;
