/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.SyncParams
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.SyncParams
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html}
 **/
var SyncParams = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.SyncParams')) {
		result = arguments[0];
	}
	else {
		result = SyncParams.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
SyncParams.prototype = Object.create(SuperClass.prototype);
SyncParams.prototype.constructor = SyncParams;

Object.defineProperty(SyncParams.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new SyncParams(this.$native.super);
	},
	enumerable: true
});

SyncParams.className = 'android.media.SyncParams';
SyncParams.prototype.className = 'android.media.SyncParams';

// class property
Object.defineProperty(SyncParams, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.SyncParams');
	},
	enumerable: true,
	configurable: false
});


// Cast
SyncParams.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new SyncParams(Hyperloop.cast('android.media.SyncParams', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#AUDIO_ADJUST_MODE_STRETCH}
 */
SyncParams.AUDIO_ADJUST_MODE_STRETCH = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#SYNC_SOURCE_SYSTEM_CLOCK}
 */
SyncParams.SYNC_SOURCE_SYSTEM_CLOCK = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#SYNC_SOURCE_VSYNC}
 */
SyncParams.SYNC_SOURCE_VSYNC = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#AUDIO_ADJUST_MODE_RESAMPLE}
 */
SyncParams.AUDIO_ADJUST_MODE_RESAMPLE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#SYNC_SOURCE_AUDIO}
 */
SyncParams.SYNC_SOURCE_AUDIO = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#AUDIO_ADJUST_MODE_DEFAULT}
 */
SyncParams.AUDIO_ADJUST_MODE_DEFAULT = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#SYNC_SOURCE_DEFAULT}
 */
SyncParams.SYNC_SOURCE_DEFAULT = 0;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function allowDefaults
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#allowDefaults()}
 **/
SyncParams.prototype.allowDefaults = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'allowDefaults',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.SyncParams') {
			return new SyncParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAudioAdjustMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#getAudioAdjustMode()}
 **/
SyncParams.prototype.getAudioAdjustMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAudioAdjustMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.SyncParams') {
			return new SyncParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSyncSource
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#setSyncSource(int)}
 **/
SyncParams.prototype.setSyncSource = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSyncSource',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.SyncParams') {
			return new SyncParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFrameRate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#setFrameRate(float)}
 **/
SyncParams.prototype.setFrameRate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFrameRate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.SyncParams') {
			return new SyncParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTolerance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#getTolerance()}
 **/
SyncParams.prototype.getTolerance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTolerance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.SyncParams') {
			return new SyncParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSyncSource
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#getSyncSource()}
 **/
SyncParams.prototype.getSyncSource = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSyncSource',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.SyncParams') {
			return new SyncParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFrameRate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#getFrameRate()}
 **/
SyncParams.prototype.getFrameRate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFrameRate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.SyncParams') {
			return new SyncParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAudioAdjustMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#setAudioAdjustMode(int)}
 **/
SyncParams.prototype.setAudioAdjustMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAudioAdjustMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.SyncParams') {
			return new SyncParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTolerance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/SyncParams.html#setTolerance(float)}
 **/
SyncParams.prototype.setTolerance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTolerance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.SyncParams') {
			return new SyncParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = SyncParams;
