/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.VolumeShaper
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.VolumeShaper
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.html}
 **/
var VolumeShaper = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.VolumeShaper')) {
		result = arguments[0];
	}
	else {
		result = VolumeShaper.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
VolumeShaper.prototype = Object.create(SuperClass.prototype);
VolumeShaper.prototype.constructor = VolumeShaper;

Object.defineProperty(VolumeShaper.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new VolumeShaper(this.$native.super);
	},
	enumerable: true
});

VolumeShaper.className = 'android.media.VolumeShaper';
VolumeShaper.prototype.className = 'android.media.VolumeShaper';

// class property
Object.defineProperty(VolumeShaper, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.VolumeShaper');
	},
	enumerable: true,
	configurable: false
});


// Cast
VolumeShaper.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new VolumeShaper(Hyperloop.cast('android.media.VolumeShaper', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(VolumeShaper, 'Configuration$Builder', {
	get: function() {
		return require('./android.media.VolumeShaper$Configuration$Builder');
	},
	enumerable: true
});
Object.defineProperty(VolumeShaper, 'Operation', {
	get: function() {
		return require('./android.media.VolumeShaper$Operation');
	},
	enumerable: true
});
Object.defineProperty(VolumeShaper, 'Configuration', {
	get: function() {
		return require('./android.media.VolumeShaper$Configuration');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getVolume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.html#getVolume()}
 **/
VolumeShaper.prototype.getVolume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getVolume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper') {
			return new VolumeShaper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function apply
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.html#apply(android.media.VolumeShaper$Operation)}
 **/
VolumeShaper.prototype.apply = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'apply',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper') {
			return new VolumeShaper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function replace
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.html#replace(android.media.VolumeShaper$Configuration, android.media.VolumeShaper$Operation, boolean)}
 **/
VolumeShaper.prototype.replace = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'replace',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper') {
			return new VolumeShaper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function finalize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.html#finalize()}
 **/
VolumeShaper.prototype.finalize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'finalize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper') {
			return new VolumeShaper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function close
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeShaper.html#close()}
 **/
VolumeShaper.prototype.close = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'close',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeShaper') {
			return new VolumeShaper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = VolumeShaper;
