/**
 * Hyperloop
 * Generated code is Copyright (c) 2020 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module MediaPlayerControl
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.widget.MediaController');

/**
 * constructor
 * http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html
 **/
var MediaPlayerControl = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.widget.MediaController$MediaPlayerControl') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.widget.MediaController$MediaPlayerControl');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
MediaPlayerControl.prototype = Object.create(SuperClass.prototype);
MediaPlayerControl.prototype.constructor = MediaPlayerControl;

Object.defineProperty(MediaPlayerControl.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MediaPlayerControl(this.$native.super);
	},
	enumerable: true
});

MediaPlayerControl.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

MediaPlayerControl.className = "android.widget.MediaController$MediaPlayerControl";
MediaPlayerControl.prototype.className = "android.widget.MediaController$MediaPlayerControl";

// class property
Object.defineProperty(MediaPlayerControl, 'class', {
	get: function() {
		return Hyperloop.getClass('android.widget.MediaController$MediaPlayerControl');
	},
	enumerable: true,
	configurable: false
});

// Cast
MediaPlayerControl.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MediaPlayerControl(Hyperloop.cast('android.widget.MediaController$MediaPlayerControl', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function isPlaying
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#isPlaying()}
 **/
MediaPlayerControl.prototype.isPlaying = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isPlaying',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#getDuration()}
 **/
MediaPlayerControl.prototype.getDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function canSeekForward
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#canSeekForward()}
 **/
MediaPlayerControl.prototype.canSeekForward = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'canSeekForward',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getBufferPercentage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#getBufferPercentage()}
 **/
MediaPlayerControl.prototype.getBufferPercentage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBufferPercentage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function canSeekBackward
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#canSeekBackward()}
 **/
MediaPlayerControl.prototype.canSeekBackward = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'canSeekBackward',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function start
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#start()}
 **/
MediaPlayerControl.prototype.start = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'start',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAudioSessionId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#getAudioSessionId()}
 **/
MediaPlayerControl.prototype.getAudioSessionId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAudioSessionId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getCurrentPosition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#getCurrentPosition()}
 **/
MediaPlayerControl.prototype.getCurrentPosition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrentPosition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function canPause
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#canPause()}
 **/
MediaPlayerControl.prototype.canPause = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'canPause',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function pause
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#pause()}
 **/
MediaPlayerControl.prototype.pause = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'pause',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function seekTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/MediaController.MediaPlayerControl.html#seekTo(int)}
 **/
MediaPlayerControl.prototype.seekTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'seekTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.MediaController$MediaPlayerControl') {
			return new MediaPlayerControl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

MediaPlayerControl.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

MediaPlayerControl.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = MediaPlayerControl;
